# zygal_ring2.py
# analyse les donnees d'une journee pour un jeu de rotor
# on manipule jeu de donnees avec ring a ZZZ
# le programme calcule les positions pour tous les ring possibles
# syntaxe: zyga_ring2.py walzen grund les_feuilles  [affiche_cycles]

import sys
import string
alpha = string.ascii_uppercase

def verifie():
    for un_grund in list(grunds.keys()):
        if un_grund not in lesData:
            return False
    return True                    

def changeGrund( rl, rm, rr ):
    newGrund = []
    for i in range(len(grunds)):
        gl, gm, gr = grunds[i]
        gl = alpha[ ( alpha.index(gl) - rl -1 )%26 ]
        gm = alpha[ ( alpha.index(gm) - rm -1 )%26 ]
        gr = alpha[ ( alpha.index(gr) - rr -1 )%26 ]
        newGrund.append( gl+gm+gr )
    return newGrund

wahlzen = sys.argv[1]
lesGrunds = sys.argv[2]
data = sys.argv[3]
if len(sys.argv) > 4:
    affCycles = True
else:
    affCycles = False

# 1. Memoriser les grunds
grunds = []
f = open( lesGrunds, "r")
while True:
    ligne = f.readline()
    if ligne == "": break
    if ligne[0] == "#": continue
    grunds.append( ligne[:3] )
#print grunds
f.close()

# 2. On memorise les feuilles de Zygalski
f = open( data, "r" )
lesData = []
lesCycles = {}
while True:
    ligne = f.readline()
    if ligne == "": 
        break
    (lncycles,wahl,ring,cycles,grund) = (ligne.strip()).split(" ")
    #print wahl, "=", ring, "=", grund
    lesData.append( grund )
    lesCycles[ grund ] = cycles

# 3. On recherche le (ou les) bons Rings
for rl in range(26):
    for rm in range(26):
        for rr in range(26):
            grundsCourant = changeGrund(rl,rm,rr)
            goodRing = True
            for unGrund in grundsCourant:
                if unGrund not in lesData: 
                    goodRing = False
                    break
            if goodRing:
                print(alpha[rl]+alpha[rm]+alpha[rr])
                if affCycles:
                    i = 0
                    for unGrund in grundsCourant:
                        print(grunds[i], unGrund, lesCycles[ unGrund ])
                        i += 1


